"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  DatePicker: () => DatePicker_default
});
module.exports = __toCommonJS(src_exports);

// src/components/DatePicker.tsx
var import_react2 = __toESM(require("react"));
var import_s_date2 = __toESM(require("@saanaa.com/s-date"));

// src/components/Header.tsx
var import_react = __toESM(require("react"));
var Header = ({ onNextMonth, onPrevMonth }) => {
  return /* @__PURE__ */ import_react.default.createElement("div", { className: "calendar__navigation fixed-position" }, /* @__PURE__ */ import_react.default.createElement("button", { type: "button", onClick: onPrevMonth }, "Previous"), /* @__PURE__ */ import_react.default.createElement("button", { type: "button", onClick: onNextMonth }, "Next"));
};
var Header_default = Header;

// src/utils.ts
var import_s_date = __toESM(require("@saanaa.com/s-date"));
var getSubTitles = (date, subTitles) => {
  if (subTitles) {
    const index = subTitles.findIndex((x) => x.date === date + "T00:00:00");
    return index >= 0 ? subTitles[index].value : null;
  }
  return null;
};
var getMonthDetails = (locale, year, month, numberOfMonth, subTitles, todayGregorian) => {
  const months = [];
  for (let monthIndex = 0; monthIndex < numberOfMonth; monthIndex++) {
    if (+month + +monthIndex === 13) {
      month = 1;
      year = +year + 1;
    } else {
      month = +month + +monthIndex;
    }
    const firstDayOfMonth = locale === "en" ? import_s_date.default.format(
      locale,
      `${year}/${month.toString().padStart(2, "0")}/01`
    ) : import_s_date.default.convert(
      "en",
      `${year}/${month.toString().padStart(2, "0")}/01`
    );
    const numberOfDays = import_s_date.default.DaysInMonth(locale, year, month);
    const days = [];
    let date = firstDayOfMonth.YYYY_MM_dd;
    for (let index = 0; index < numberOfDays; index++) {
      const masterDate = import_s_date.default.format(locale, date);
      const gregorianDate = import_s_date.default.format("en", date);
      const jalaliDate = import_s_date.default.convert("fa", gregorianDate.YYYY_MM_dd);
      days.push({
        // @ts-ignore
        value: gregorianDate.YYYY_MM_dd.replaceAll("/", ""),
        gregorianDate: gregorianDate.YYYY_MM_dd,
        jalaliDate: jalaliDate.YYYY_MM_dd,
        year: masterDate.YYYY,
        month: masterDate.MM,
        monthName: masterDate.M,
        day: masterDate.d,
        weekDay: masterDate.W,
        weekDayNumber: masterDate.WW,
        isPassed: import_s_date.default.datoToNumber(date) < import_s_date.default.datoToNumber(todayGregorian),
        subTitle: getSubTitles(
          import_s_date.default.format("en", date, "-").YYYY_MM_dd,
          subTitles
        )
      });
      date = import_s_date.default.addDays("en", date, 1).YYYY_MM_dd;
    }
    months.push({
      year: import_s_date.default.format(locale, firstDayOfMonth.YYYY_MM_dd).YYYY,
      month: import_s_date.default.format(locale, firstDayOfMonth.YYYY_MM_dd).MM,
      monthName: import_s_date.default.format(locale, firstDayOfMonth.YYYY_MM_dd).M,
      days
    });
  }
  return months;
};

// src/components/DatePicker.tsx
var DatePicker = ({
  onChange,
  // title = 'تاریخ انتخابی',
  numberOfMonth = 1,
  subTitles = [],
  isDisabledPast = true,
  submitBtnAction = () => {
  }
}) => {
  const [localeState, setLocaleState] = (0, import_react2.useState)("fa");
  const [localeTitle, setLocaleTitle] = (0, import_react2.useState)("\u062A\u0642\u0648\u06CC\u0645 \u0645\u06CC\u0644\u0627\u062F\u06CC");
  const [selectedDate, setSelectedDate] = (0, import_react2.useState)();
  const [monthsState, setMonthsState] = (0, import_react2.useState)([]);
  const todayGregorian = import_s_date2.default.format("en", /* @__PURE__ */ new Date(), "/").YYYY_MM_dd;
  let currentYear = import_s_date2.default.convert("fa", /* @__PURE__ */ new Date()).YYYY;
  let currentMonth = import_s_date2.default.convert("fa", /* @__PURE__ */ new Date()).MM;
  (0, import_react2.useEffect)(() => {
    setMonthsState(
      getMonthDetails(
        "fa",
        currentYear,
        currentMonth,
        numberOfMonth,
        subTitles,
        todayGregorian
      )
    );
  }, [numberOfMonth, subTitles, todayGregorian, currentYear, currentMonth]);
  const toggleCalendarType = () => {
    const newLocale = localeState === "en" ? "fa" : "en";
    setLocaleState(newLocale);
    setLocaleTitle(newLocale === "en" ? "\u062A\u0642\u0648\u06CC\u0645 \u0634\u0645\u0633\u06CC" : "\u062A\u0642\u0648\u06CC\u0645 \u0645\u06CC\u0644\u0627\u062F\u06CC");
    currentYear = import_s_date2.default.format(newLocale, /* @__PURE__ */ new Date()).YYYY;
    currentMonth = import_s_date2.default.format(newLocale, /* @__PURE__ */ new Date()).MM;
    setMonthsState(
      getMonthDetails(
        newLocale,
        currentYear,
        currentMonth,
        numberOfMonth,
        subTitles,
        todayGregorian
      )
    );
  };
  const nextMonth = () => {
    if (+currentMonth + 1 === 13) {
      currentYear++;
      currentMonth = 1;
    } else {
      currentMonth++;
    }
    setMonthsState(
      getMonthDetails(
        localeState,
        currentYear,
        currentMonth,
        numberOfMonth,
        subTitles,
        todayGregorian
      )
    );
  };
  const prevMonth = () => {
    if (isDisabledPast && +currentMonth === +import_s_date2.default.convert(localeState, /* @__PURE__ */ new Date()).MM && +currentYear === +import_s_date2.default.convert(localeState, /* @__PURE__ */ new Date()).YYYY)
      return;
    if (+currentMonth - 1 === 0) {
      currentYear--;
      currentMonth = 12;
    } else {
      currentMonth--;
    }
    setMonthsState(
      getMonthDetails(
        localeState,
        currentYear,
        currentMonth,
        numberOfMonth,
        subTitles,
        todayGregorian
      )
    );
  };
  const gotoToday = () => {
    setMonthsState(
      getMonthDetails(
        localeState,
        currentYear,
        currentMonth,
        numberOfMonth,
        subTitles,
        todayGregorian
      )
    );
  };
  const handleChange = (date) => {
    setSelectedDate(date);
    onChange(date.jalaliDate);
  };
  return /* @__PURE__ */ import_react2.default.createElement(
    "div",
    {
      className: `calendar ${numberOfMonth > 1 ? "active" : ""} ${localeState === "fa" ? "-rtl" : "-ltr"}`
    },
    /* @__PURE__ */ import_react2.default.createElement("div", { className: "calendar__navigation fixed-position" }, /* @__PURE__ */ import_react2.default.createElement("button", { type: "button", onClick: gotoToday }, "\u0628\u0631\u0648 \u0628\u0647 \u0627\u0645\u0631\u0648\u0632"), /* @__PURE__ */ import_react2.default.createElement("button", { type: "button", onClick: toggleCalendarType }, localeTitle)),
    /* @__PURE__ */ import_react2.default.createElement("div", { className: "s-relative s-block s-w-full" }, /* @__PURE__ */ import_react2.default.createElement(Header_default, { onNextMonth: nextMonth, onPrevMonth: prevMonth }), /* @__PURE__ */ import_react2.default.createElement("div", { className: "s-grid s-gap-8 s-p-3 md:s-flex" }, monthsState.map((monthItem, monthIndex) => /* @__PURE__ */ import_react2.default.createElement("div", { key: monthIndex, className: "s-mt-[2px] s-flex-1" }, /* @__PURE__ */ import_react2.default.createElement("div", { className: "s-mx-1.5 s-grid s-grid-cols-5 s-items-center s-gap-x-3 s-pb-2 s-pt-4" }, /* @__PURE__ */ import_react2.default.createElement("span", { className: "s-col-span-5 s-mb-2 s-text-left s-text-base s-font-semibold s-text-black md:s-text-sm" }, `${monthItem.monthName} ${monthItem.year}`), ["\u0634", "\u06CC", "\u062F", "\u0633", "\u0686", "\u067E", "\u062C"].map(
      (weekDay, weekIndex) => /* @__PURE__ */ import_react2.default.createElement(
        "span",
        {
          key: weekIndex,
          className: "s-text-center s-text-sm s-font-semibold s-text-slate-600"
        },
        weekDay
      )
    ), monthItem.days.map((dayItem, dayIndex) => /* @__PURE__ */ import_react2.default.createElement("div", { key: dayIndex, className: "s-relative s-mt-2" }, /* @__PURE__ */ import_react2.default.createElement(
      "button",
      {
        type: "button",
        onClick: () => handleChange(dayItem),
        className: `${selectedDate && selectedDate.value === dayItem.value ? "selected" : ""} ${dayItem.isPassed ? "s-text-gray-400" : "s-text-gray-700"} s-flex s-h-12 s-w-12 s-items-center s-justify-center s-bg-transparent`,
        disabled: dayItem.isPassed
      },
      dayItem.day
    ), dayItem.subTitle && /* @__PURE__ */ import_react2.default.createElement("span", { className: "s-absolute s-right-0 s-top-0 s-flex s-h-4 s-w-4 s-items-center s-justify-center s-rounded-full s-bg-red-500 s-text-xs s-text-white" }, dayItem.subTitle))))))), /* @__PURE__ */ import_react2.default.createElement("div", { className: "s-relative s-mt-8 s-w-full s-pb-4" }, /* @__PURE__ */ import_react2.default.createElement(
      "button",
      {
        type: "button",
        className: "s-btn s-btn-primary s-w-full",
        onClick: submitBtnAction
      },
      "\u062B\u0628\u062A \u062A\u0627\u0631\u06CC\u062E"
    )))
  );
};
var DatePicker_default = DatePicker;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DatePicker
});
//# sourceMappingURL=index.js.map